<template>
  <AppWrapper>
    <v-container>
      <v-row>
        <h1>Proposals management</h1>
      </v-row>
      <v-row>

        <v-col cols="3" lg="3" md="6" sm="12" v-for="item in proposalList" :key="item.id">
          <ProposalCard
            :proposal="item"
            @details="openDetails(item)"
            @delete="confirmDelete(item)"
            @edit="onEditClick(item)"
          />
        </v-col>
      </v-row>
    </v-container>
    <v-btn fab bottom fixed right color="primary" @click="onCreateClick">
      <v-icon>add</v-icon>
    </v-btn>

    <v-dialog v-model="detailsOpened" width="50%">
      <ProposalDetailsPopup @close="detailsOpened=false" :proposal="detailsProposal"/>
    </v-dialog>

    <v-dialog v-model="deleteOpened" width="22em">
      <v-card>
        <v-card-title class="headline">
          Delete this proposal?
        </v-card-title>

        <v-card-text>
          Are you sure to delete this migration proposal? All data will be lost, including workplace and accommodation
          detailsm and chats with candidates.
        </v-card-text>
        <v-divider/>
        <v-card-actions>
          <v-btn text @click="onConfirmDeleteItem">Confirm</v-btn>
          <v-spacer/>
          <v-btn text @click="deleteOpened = false">Cancel</v-btn>

        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-dialog fullscreen v-model="formOpened">
      <ProposalCreateEditPopup
        :proposal="formItem"
        :action="formAction"
        @close="formOpened=false"
        @update="onUpdateItems"
      />
    </v-dialog>
  </AppWrapper>

</template>

<script>
import AppWrapper from "@/components/common/AppWrapper";
import ProposalCard from "@/components/proposals/ProposalCard";
import ProposalDetailsPopup from "@/components/proposals/ProposalDetailsPopup";
import ProposalCreateEditPopup from "@/components/proposals/ProposalCreateEditPopup";

export default {
  name: "proposals.vue",
  components: {ProposalCreateEditPopup, ProposalDetailsPopup, ProposalCard, AppWrapper},
  data() {
    return {
      detailsOpened: false,
      detailsProposal: null,
      deleteOpened: false,
      deleteCandidate: {},
      formOpened: false,
      formAction: 'create',
      formItem: null,
    }
  },

  mounted() {
    this.$store.dispatch('loadCountries');
    this.$store.dispatch('loadProposals');
  },

  computed: {
    proposalList() {
      return this.$store.state.proposals;
    }
  },

  methods: {
    openDetails(item) {
      this.detailsOpened = true;
      this.detailsProposal = item;
    },

    confirmDelete(item) {
      this.deleteOpened = true;
      this.deleteCandidate = item;
    },

    onConfirmDeleteItem() {
      this.deleteOpened = false;
      this.$store.dispatch('deleteProposal', this.deleteCandidate);
    },

    onCreateClick() {
      this.formOpened = true;
      this.formItem = null;
      this.formAction = 'create';
    },

    onEditClick(item) {
      this.formOpened = true;
      this.formItem = item;
      this.formAction = 'edit';
    },

    onUpdateItems({action, proposal}) {
      this.formOpened = false;
      console.log(action, proposal);

      switch (action) {
        case 'create':
          this.$store.dispatch('createProposal', proposal);
          break;

        case 'edit':
          proposal.CountryId = proposal.countryId || proposal.country.id;
          delete proposal.country;
          this.$store.dispatch('updateProposal', proposal);
          break;
      }
    }
  }
}
</script>
